/*****************************************************************************
 *
 * cgi_del_policy - cgi to define the delete policies
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <libpp_common.h>
#include <config.h>
#include <gettext.h>
#include "common.h"
#include "cgi_del_policy.h"
#include "object_users.h"

/* Local CGI */
char *sHost;
char *sService;
char *sMetric;

void getDelReportCGI();

void displayEditHostDefaults()
{
	int bHeader = FALSE;
	int iPolicy, iDefaultBinPolicy, iDefaultRawPolicy;
	char sHostHash[9];
	int iPolicyType;
	TPolicyList *first, *p;
	char sColour[7];
	char sTemplate[21];
	int iLine = 0, iRow, bSubmit;

	int iNewPolicyType, iNewPolicy = 0;
	int iUserPolicy = 0;
	char sNewTemplate[21];
	int bHit = FALSE;

	char sHashPoli[15], sHashUser[15], sHashDays[15];

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getDelReportCGI();

	showHeader(_("Deletion Policies for Hosts"), "");

	selectGroup("edit_host_delete_policies", TRUE);
	if (!user.sGroupName[0]) return;

	iDefaultBinPolicy = getDefaultBinPolicy();
	iDefaultRawPolicy = getDefaultRawPolicy();

	// Get the policy list:
	first = getPolicyList();

	printf("<form method=get>");
	printf("<input type=hidden name=\"submit\" value=%d>", iLine + 1);
	printf("<input type=hidden name=\"edit_host_delete_policies\" value=\"1\">\n");
	printf("<input type=hidden name=\"submit\" value=\"1\">\n");

	bSubmit = icgi("submit", 0);

	g_string_printf(s_SQL, "SELECT host_name, ");
	g_string_append_printf(s_SQL, " bin_delete_policy, bin_delete_policy_name, bin_delete_policy_type,");
	g_string_append_printf(s_SQL, " raw_delete_policy, raw_delete_policy_name, raw_delete_policy_type");
	g_string_append_printf(s_SQL, " FROM perfdata_host");
	if (strcmp(user.sGroupName, "**ALL**"))
		g_string_append_printf(s_SQL, " WHERE group_name = '%s'", sql_escape(user.sGroupName,PERCENT_ESCAPE_CHAR));
	query(s_SQL->str);

	iRow = 0;

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0 ;currentRow<numberOfRows; currentRow++) {
	#endif
	
		if (!bHeader) {
			bHeader = TRUE;
			printf("<p align=center>\n");
			printf("  <table width=\"95%%\" border=1 cellpadding=2 cellspacing=0>\n");
			printf("    <tr bgcolor=\"#FFFFCC\">\n");
			printf("      <td align=center>%s<b>Host</b></font></td>\n", FONT);
			printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("Domain"));
			printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("Policy"));
			if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
				printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("User&nbsp;Defined&nbsp;Policy"));
			}
			printf("    </tr>\n");
		}

		iRow++;

		strcpy(sColour, "FFFFFF");
		strcpy(sHostHash, s_hash(sData(0)));

		for (iLine = 0; iLine < 2; iLine++) {

			sprintf(sHashPoli, "P%x", iRow * 2 + iLine);
			sprintf(sHashUser, "T%x", iRow * 2 + iLine);
			sprintf(sHashDays, "D%x", iRow * 2 + iLine);

			if (iLine == 0) {
				/* Bin */
				iPolicy = sql2pval(sData(1));
				strcpy(sTemplate, sData(2));
				iPolicyType = sql2ptype(sData(3));
			} else {
				/* Raw */
				iPolicy = sql2pval(sData(4));
				strcpy(sTemplate, sData(5));
				iPolicyType = sql2ptype(sData(6));
			}

			/* Handle an incomming value */
			if (bSubmit) {

				strcpy(sNewTemplate, scgi(sHashPoli));

				if (!strcmp(sNewTemplate, "*USER*")) {
					iNewPolicyType = DP_USER;
					iUserPolicy = icgi(sHashUser, iPolicy);
					if (iUserPolicy == 0) iNewPolicy = -1;
					else if (iUserPolicy == 1) iNewPolicy = 0;
					else iNewPolicy = icgi(sHashDays, 0);
				} else {
					iNewPolicyType = DP_TEMPLATE;
					iNewPolicy = getPolicy(sNewTemplate);
				}


				if (strcmp(sNewTemplate, sTemplate) ||
					iNewPolicyType != iPolicyType ||
					iNewPolicy != iPolicy) {

					/* Save New policy here */
					if (iLine == 0) {
						setBinHostPolicyUser(sData(0), iNewPolicy);
					} else {
						setRawHostPolicyUser(sData(0), iNewPolicy);
					}

					iPolicyType = iNewPolicyType;
					strcpy(sTemplate, sNewTemplate);
					iPolicy = iNewPolicy;

				}

			} // END if (sbumit)


/*

				if (!strcmp(scgi("host"), sData(0))) {
	
					sNewTemplate = strdup(scgi("policy_name"));
	
					if (!strcmp(sNewTemplate, "*USER*")) {
	
						// Set to User Policy 
						iNewPolicyType = DP_USER;
						iUserPolicy = icgi(sHostHash, 0);
						if (iUserPolicy == 0) iNewPolicy = -1;
						else if (iUserPolicy == 1) iNewPolicy = 0;
						else iNewPolicy = icgi("days", 0);;
						if (iPolicyType != iNewPolicyType || iNewPolicy != iPolicy) {
							if (iLine == 0) {
								setBinHostPolicyUser(sData(0), iNewPolicy);
							} else {
								setRawHostPolicyUser(sData(0), iNewPolicy);
							}
						}
	
					} else {
	
						// Set to a template 
						iNewPolicyType = DP_TEMPLATE;
						if (iPolicyType != iNewPolicyType || strcmp(sNewTemplate, sTemplate)) {
							if (iLine == 0) {
								setBinHostPolicyTemplate(sData(0), sNewTemplate);
							} else {
								setRawHostPolicyTemplate(sData(0), sNewTemplate);
							}
						}
						iNewPolicy = getPolicy(sNewTemplate);
	
					}
	
					iPolicyType = iNewPolicyType;
					strcpy(sTemplate, sNewTemplate);
					iPolicy = iNewPolicy;
					free(sNewTemplate);
					
				}
			}

*/
			printf("    <tr bgcolor=\"#%s\">\n", sColour);
	
			// Host Name:
			if (iLine == 0) 
				printf("<td rowspan=2 valign=top>%s%s</font></td>\n", FONT, sData(0));

			// Domain:
			if (iLine == 0) 
				printf("<td>%sBinary&nbsp;Data</font></td>\n", FONT);
			else
				printf("<td>%sRaw&nbsp;Data</font></td>\n", FONT);

			// User Policy Value
			printf("<td>%s", FONT);
			if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {

				printf("<select name=\"%s\">\n", sHashPoli);
				printf("<option value=\"*USER*\"%s>&lt;%s&gt;\n", 
					(iPolicyType == DP_USER) ? " selected" : "", gettext(STRING_DELETE_POLICY_USER_DEFINED));
				for (p = first; p != NULL; p = p->next) {
					printf("<option value=\"%s\"%s>%s\n",
						p->sName,
						(!strcmp(p->sName, sTemplate) && iPolicyType == DP_TEMPLATE) ? " selected" : "",
						p->sName);
				}
				printf("</select></font></td>");

			} else {
				printf("<nobr>");
				if (iPolicyType == DP_USER) {
					printf("%s", gettext(STRING_DELETE_POLICY_USER_DEFINED));
					switch (iPolicy) {
						case -1:
							printf(_(" - Never"));
							break;
						case 0:
							printf(_(" - Always"));
							break;
						default:
							printf(_(" - After %d Days"), iPolicy);
							break;
					}
				}
				else {
					for (p = first; p != NULL; p = p->next) {
						if (!strcmp(p->sName, sTemplate) && iPolicyType == DP_TEMPLATE) {
							printf("%s\n", p->sName);
							bHit = TRUE;
							break;
						}
					}
					if (!bHit) printf("Unknown\n");
				}
			}
	
			// User Policy
			if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
				printf("<td><nobr>%s\n", FONT);
				printf("<input type=radio name=\"%s\" value=\"0\"%s>%s&nbsp;&nbsp;", 
					sHashUser, (iPolicy == -1) ? " checked" : "",_("Never"));
				printf("<input type=radio name=\"%s\" value=\"1\"%s>%s&nbsp;&nbsp;", 
					sHashUser, (iPolicy == 0) ? " checked" : "",_("Always"));
				printf("<input type=radio name=\"%s\" value=\"2\"%s>%s:&nbsp;", 
					sHashUser, (iPolicy > 0) ? " checked" : "",_("After&nbsp;Days"));
				printf("<input type=text name=\"%s\" value=\"%d\" size=3 maxlength=6>\n", 
					sHashDays,
					(iPolicy > 0) ? iPolicy : (iLine == 0) ? 
					(iDefaultBinPolicy > 0) ? iDefaultBinPolicy : 0 : 
					(iDefaultRawPolicy > 0) ? iDefaultRawPolicy : 0);
				printf("</nobr></td>\n");
			}
	
			printf("</tr>\n");


		} // END FOR	

	} // END WHILE

	if (bHeader) printf("</table></p>\n");

	// Submit
	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<p align=center><input type=submit value=\"%s\"></p></form>\n",_("Save Policies"));
	}




}



void displayEditDeletePolicies()
{

	int bHeader = FALSE;
	char sDelete[80], sEdit[80];
	char *s, *sHash, *sAction;
	char sColour[7];
	int bDeleted = FALSE;
	int iPolicy = 0;
	char sPolicy[200];

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getDelReportCGI();

	showHeader(_("Deletion Policy Templates"), "");

	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {

		// Add:

		sAction = strdup(scgi("enter"));
		s = strdup(scgi("policy_name"));
		if (icgi("addedit", 0) && s[0] && !strcmp(sAction, "Enter")) {
			int iDays;
			iPolicy = icgi("delete_policy", 0);
			iDays = icgi("days", 0);

			switch (iPolicy) {
			case 0:
				// Never.  delete_policy = NULL.
				editPolicy(s, -1);
				break;
			case 1:
				// Always.  delete_policy = 0.
				editPolicy(s, 0);
				break;
			case 2:
				// Specific days.  delete_policy = iDaysIn
				editPolicy(s, iDays);
				break;
			}

		} // END IF
		free(s);
		free(sAction);

		// Edit
		s = strdup(scgi("edit_policy"));
		if (s[0]) {
			iPolicy = getPolicy(s);
		} else {
			iPolicy = getDefaultBinPolicy();
		}

		/* Add or Edit policy */

		printf("<form method=\"get\">\n");
		printf("<input type=hidden name=\"edit_delete_policies\" value=\"1\">\n");
		printf("<input type=hidden name=\"addedit\" value=\"1\">\n");

		printf("<p align=center>\n");
		printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
		printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

		printf("  <tr>\n");
		printf("    <td align=center>%s\n", FONT);
		if (s[0]) {
			printf("      <b>%s:</b>\n", _("Edit Policy"));
		} else {
			printf("      <b>%s:</b>\n", _("Add Policy"));
		}
		printf("    </font></td>\n");
		printf("    <td><nobr>%s", FONT);
		if (s[0]) {
			printf("<input type=hidden name=\"policy_name\" value=\"%s\">", s);
			printf("<table width=100 border=1 cellspacing=0 cellpadding=2><tr bgcolor=\"#FFFFFF\"><td>");
			printf("%s%s", FONT, s);
			printf("</font></td></tr></table>");
			printf("</font></td><td>%s\n", FONT);
		} else {
			printf("<input name=\"policy_name\" value=\"%s\" size=20 maxlength=20>\n", s);
		}
		printf("<input type=radio name=\"delete_policy\" value=\"0\"%s>%s&nbsp;&nbsp;", 
			(iPolicy == -1) ? " checked" : "",_("Never"));
		printf("<input type=radio name=\"delete_policy\" value=\"1\"%s>%s&nbsp;&nbsp;", 
			(iPolicy == 0) ? " checked" : "",_("Always"));
		printf("<input type=radio name=\"delete_policy\" value=\"2\"%s>%s:", 
			(iPolicy > 0) ? " checked" : "",_("After&nbsp;Days"));
		printf("<input type=text name=\"days\" value=\"%d\" size=4 maxlength=6>\n", 
			DEFAULT_DELETE_POLICY_DAYS);
		printf("<input type=submit value=\"%s\" name=\"enter\">\n",_("Enter"));
		if (s[0]) printf("<input type=submit value=\"%s\" name=\"enter\">\n",_("Cancel"));
		printf("</td></form>\n");
		printf("  </tr>\n");
		printf("  </table>\n");

		printf("</td></tr></table></p>\n");

		free(s);

	} // END "rw" access

	// Table

	query("SELECT policy_name, delete_policy FROM perfdata_delete_policy ORDER BY policy_name");

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++) {
	#endif
		sHash = s_hash(sData(0));

		// Do we deletre this entry?
		s = scgi("delete");
		if (!strcmp(s, sHash)) {
			deletePolicyName(sData(0));
			strcpy(sColour, "FFCCCC");
			bDeleted = TRUE;
		} else {
			strcpy(sColour, "FFFFFF");
			bDeleted = FALSE;
		}

		// Interperate Policy
		#ifdef USE_DB_MYSQL
		if (!result_row[1]) {
		#elif defined USE_DB_POSTGRESQL
		if(!PQgetvalue(query_result,currentRow,1)) {
		#endif
			iPolicy = -1;
			strcpy(sPolicy, _("Never"));
		} else {
			iPolicy = iData(1);
			if (iPolicy) {
				sprintf(sPolicy, _("After&nbsp;%d&nbsp;Days"), iPolicy);
			} else {
				sprintf(sPolicy, _("Always"));
			}
		}

		if (!bHeader) {
			bHeader = TRUE;
			printf("<p align=center>\n");
			printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
			printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

			printf("  <tr>\n");
			printf("    <td align=center>%s\n", FONT);
			printf("      <b>%s</b><br>\n",_("Policies"));
			printf("    </td>\n");
			printf("  </tr>\n");
			printf("  </table>\n");

			printf("  <table width=\"100%%\" border=1 cellpadding=2 cellspacing=0>\n");
			printf("    <tr bgcolor=\"#FFFFCC\">\n");
			printf("      <td align=center>%s<b>%s</td>\n", FONT,_("Policy&nbsp;Name"));
			printf("      <td align=center width=\"1%%\">%s<b>%s</font></td>\n", FONT,_("Policy&nbsp;Value"));
			if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
				printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("Edit"));
				printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT,_("Delete"));
			}
			printf("    </tr>\n");
		}

		if (isDefaultDP(sData(0)))
			sprintf(sDelete, _("(Built&nbsp;In)"));
		else
			sprintf(sDelete, "<a href=\"%s?edit_delete_policies=1&delete=%s\">%s</a>", sProgName, sHash,_("Delete"));
		sprintf(sEdit, "<a href=\"%s?edit_delete_policies=1&edit_policy=%s\">%s</a>", sProgName, url_encode(sData(0)), _("Edit"));


		printf("    <tr bgcolor=\"#%s\">\n", sColour);
		
		// Policy Name:
		printf("      <td>%s%s</font></td>\n", FONT, sData(0));

		// Policy Value:
		printf("      <td>%s%s</font></td>\n", FONT, sPolicy);

		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {

			// Edit Policy:
			printf("      <td align=center>%s%s</font></td>\n", FONT, sEdit);

			// Delete Options:
			if (bDeleted) {
				printf("      <td colspan=3 align=center>%s<b>%s</b></font></td>\n", FONT, _("Deleted."));
			} 
			else {
				printf("      <td align=center>%s%s</font></td>\n", FONT, sDelete);
			}

		}

		printf("    </tr>\n");


	}

	if (bHeader) printf("</table></tr></td></table></p>\n");
	

}



void displayDeletePolicyRaw()
{
	char sColour[7] = "FFFFFF";
	char sColourHead[7] = "FFFFFF";
	char *sHash;
	char iPolicyIn;
	int  iDefaultPolicy, iDefaultHostPolicy;
	int  iDaysIn, iPolicy = -1;
	char sDaysOut[15];
	TPolicyList *first, *p;
	char sTmp[100];
	int iPolicyType, iPolicyTypeIn;
	char sPolicyName[21], sPolicyNameIn[21];
	int bHit = FALSE;
	int isResultRow;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getDelReportCGI();

	showHeader(_("Deletion Policy for Raw Data"), "");

	selectGroup("delete_policy_raw", FALSE);

	if (!user.sGroupName[0]) {
		printf("  </table>\n");
		printf("</td></tr></table></p>\n");
		return;
	}

	/* select a host */
	printf("<form method=get>\n");
	printf("<input type=hidden name=\"delete_policy_raw\" value=\"1\">\n");
	
	printf("  <tr>\n");
	printf("    <td align=right width=\"33%%\">%s\n", FONT);
	printf("      %s:&nbsp;&nbsp;\n",_("Select Host"));
	printf("    </font></td>\n");
	printf("    <td>\n");
	printf("    <select name=\"host\">\n");

	g_string_printf(s_SQL, "SELECT perfdata_host.host_name, count(service_description)");
	g_string_append_printf(s_SQL, " FROM perfdata_service JOIN perfdata_host ON perfdata_service.host_name = perfdata_host.host_name");
	if (strcmp(user.sGroupName, "**ALL**"))
		g_string_append_printf(s_SQL, " WHERE group_name = '%s'", sql_escape(user.sGroupName,PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, " GROUP BY perfdata_host.host_name");
	query(s_SQL->str);

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow=0;currentRow<numberOfRows;currentRow++){
	#endif
	
		printf("    <option value=\"%s\"%s>%s&nbsp;&nbsp;&nbsp;(%d %s%s)\n", 
			sData(0), 
			(!strcmp(sHost, sData(0))) ? " selected" : "", 
			sData(0), 
			iData(1), _("Service"),
			(iData(1) == 1) ? "" : "s");
	}

	printf("    </select>\n");
	printf("     </td>\n");
	printf("     <td>\n");
	printf("    <input type=submit value=\"%s\">\n",_("Select Host"));
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("</table>\n");

	if (!sHost[0]) {
		printf("</td></form></tr></table></p>\n");
		return;
	} 

	/* Show default host policy */

	iDefaultHostPolicy = getRawHostPolicy(sHost);
	printf("<tr><td align=center>%s%s: %s</font></td></tr>\n",
		FONT, _("Default policy for this host"),getPolicyDesc(iDefaultHostPolicy));
	printf("</td></form></tr></table></p>\n");
			

	/* Some defaults */
	iDefaultPolicy = getDefaultRawPolicy();
	first = getPolicyList();

	/* Adjust policy */
	printf("<form method=get>\n");
	printf("<input type=hidden name=\"delete_policy_raw\" value=\"1\">\n");
	printf("<input type=hidden name=\"host\" value=\"%s\">\n", sHost);
	
	/* main table */
	printf("<p align=center><table width=\"600\" border=1 cellspacing=0 cellpadding=2>\n");
	fflush(stdout);

	printf("<tr bgcolor=\"#FFFFCC\">\n");
	printf("  <td align=center>%s<b>Service</b></font></td>\n", FONT);
	printf("  <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("Policy"));
	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("  <td align=center width=\"1%%\">%s<b>%s</font></td>\n", FONT,_("User&nbsp;Defined&nbsp;Policy"));
	}
	printf("</tr>\n");

	g_string_printf(s_SQL, "SELECT service_description, raw_delete_policy, raw_delete_policy_name, raw_delete_policy_type FROM perfdata_service WHERE host_name = '%s'",
		sql_escape(sHost,PERCENT_ESCAPE_CHAR));
	query(s_SQL->str);

	sService[0] = 0;
	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif

		sHash = s_hash(sData(0));
		sprintf(sDaysOut, "d%sd", sHash);
	
		iPolicyType = sql2ptype(sData(3));
		strcpy(sPolicyName, sData(2));

		/* New values from CGI */
		iPolicyIn = icgi(sHash, -1);
		iDaysIn = icgi(sDaysOut, 0);

		sprintf(sTmp, "pn%s", sHash);
		strcpy(sPolicyNameIn, scgi(sTmp));
		if (sPolicyNameIn[0]) {
			if (!strcmp(sPolicyNameIn, "*USER*")) iPolicyTypeIn = DP_USER;
			else if (!strcmp(sPolicyNameIn, "*HOST*")) iPolicyTypeIn = DP_HOST;
			else iPolicyTypeIn = DP_TEMPLATE;
		} else iPolicyTypeIn = DP_UNSET;

		/* Set policy if changed */
		switch (iPolicyTypeIn) {
		case DP_TEMPLATE:
			iPolicy = getPolicy(sPolicyNameIn);
			if (iPolicyType != DP_TEMPLATE || strcmp(sPolicyName, sPolicyNameIn)) {
				setRawPolicy(sHost, sData(0), iPolicy, DP_TEMPLATE, sPolicyNameIn);
				iPolicyType = iPolicyTypeIn;
				strcpy(sPolicyName, sPolicyNameIn);
			}
			break;
		case DP_HOST:
			iPolicy = iDefaultHostPolicy;
			if (iPolicyType != DP_HOST) {
				setRawPolicy(sHost, sData(0), iPolicy, DP_HOST, "");
				iPolicyType = iPolicyTypeIn;
			}
			break;
		case DP_USER:
			// What is policy?
			// 1. From CGI.
			// 2. From SQL.
			#ifdef USE_DB_MYSQL
			isResultRow = result_row[1] ? TRUE : FALSE;
			#elif defined USE_DB_POSTGRESQL
			isResultRow = PQgetvalue(query_result,currentRow,1) ? TRUE : FALSE;
			#endif
			switch (iPolicyIn) {
			case 0:
				// Never.  delete_policy = NULL.
				iPolicy = -1;
				if (isResultRow || iPolicyType != DP_USER) {
					setRawPolicy(sHost, sData(0), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			case 1:
				// Always.  delete_policy = 0.
				iPolicy = 0;
				if (!isResultRow || iData(1) != 0 || iPolicyType != DP_USER) {
					setRawPolicy(sHost, sData(0), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			case 2:
				// Specific days.  delete_policy = iDaysIn
				iPolicy = iDaysIn;
				if (!isResultRow || iData(1) == 0 || iDaysIn != iData(1) || iPolicyType != DP_USER) {
					setRawPolicy(sHost, sData(0), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			default:
				// No data. Leave as default.
				iPolicy = iDefaultPolicy;
				break;
			}
			break;
		} // END case (policy type)


		printf("<tr>\n");

		/* Service */
		if (!strcmp(sData(0), sService)) {
			printf("  <td bgcolor=\"#%s\"><font size=2>&nbsp;</td>\n", sColourHead);
		} else {
			strcpy(sService, sData(0));
			printf("  <td bgcolor=\"#%s\">%s&nbsp;%s&nbsp;</font></td>\n", sColourHead, FONT, sService);
		}

		// User Policy Value
		printf("<td bgcolor=\"#%s\" align=center>%s", sColourHead, FONT);

		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {

			printf("<select name=\"pn%s\">\n", sHash);
			printf("<option value=\"*USER*\"%s>&lt;%s&gt;\n", 
				(iPolicyType == DP_USER) ? " selected" : "",gettext(STRING_DELETE_POLICY_USER_DEFINED));
			printf("<option value=\"*HOST*\"%s>&lt;%s&gt;\n", 
				(iPolicyType == DP_HOST) ? " selected" : "",gettext(STRING_DELETE_POLICY_HOST_DEFAULT));
			for (p = first; p != NULL; p = p->next) {
				printf("<option value=\"%s\"%s>%s\n",
					p->sName,
					(!strcmp(p->sName, sPolicyName) && iPolicyType == DP_TEMPLATE) ? " selected" : "",
					p->sName);
			}
			printf("</select></td>\n");

		} else {

			printf("<nobr>");
			if (iPolicyType == DP_USER) {
				printf(gettext(STRING_DELETE_POLICY_USER_DEFINED));
				switch (iPolicy) {
					case -1:
						printf(_(" - Never"));
						break;
					case 0:
						printf(_(" - Always"));
						break;
					default:
						printf(_(" - After %d Days"), iPolicy);
						break;
				}
			}
			if (iPolicyType == DP_HOST) {
				printf(gettext(STRING_DELETE_POLICY_HOST_DEFAULT));
				switch (iPolicy) {
					case -1:
						printf(_(" - Never"));
						break;
					case 0:
						printf(_(" - Always"));
						break;
					default:
						printf(_(" - After %d Days"), iPolicy);
						break;
				}
			}
			else {
				for (p = first; p != NULL; p = p->next) {
					if (!strcmp(p->sName, sPolicyName) && iPolicyType == DP_TEMPLATE) {
						printf("%s\n", p->sName);
						bHit = TRUE;
						break;
					}
				}
				if (!bHit) printf(_("Unknown\n"));
			}

		}
	
	

		/* Policy */
		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
			printf("  <td bgcolor=\"#%s\">%s<nobr>", sColour, FONT);
			printf("<input type=radio name=\"%s\" value=\"0\"%s>%s&nbsp;&nbsp;", 
				sHash, (iPolicy == -1) ? " checked" : "",_("Never"));
			printf("<input type=radio name=\"%s\" value=\"1\"%s>%s&nbsp;&nbsp;", 
				sHash, (iPolicy == 0) ? " checked" : "",_("Always"));
			printf("<input type=radio name=\"%s\" value=\"2\"%s>%s:", 
				sHash, (iPolicy > 0) ? " checked" : "",_("After&nbsp;Days"));
			printf("<input type=text name=\"%s\" value=\"%d\" size=4 maxlength=6>\n", 
				sDaysOut, (iPolicy > 0) ? iPolicy : 
				(iDefaultPolicy > 0) ? iDefaultPolicy : 0);
			printf("  </font></td>\n");
		}

		printf("</tr>\n");

	}

	printf("</table></p>\n");


	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<p align=center>\n");
		printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\">\n");
		printf("<tr>\n");
		printf("  <td align=center><input type=submit value=\"%s\"></td>\n",_("Update Policy"));
		printf("</tr>\n");
		printf("</table></p>\n");
	}

	printf("</form>\n");



}


void displayDeletePolicyBin()
{
/* Deletion policy for binary data. Ie, data in perfdata_bin */



	char sColour[7] = "FFFFFF";
	char sColourHead[7] = "FFFFFF";
	char *sHash;
	char iPolicyIn;
	int  iDefaultPolicy, iDefaultHostPolicy;
	int  iDaysIn, iPolicy = -1;
	char sDaysOut[15];
	TPolicyList *first, *p;
	char sTmp[100];
	int iPolicyType, iPolicyTypeIn;
	char sPolicyName[21], sPolicyNameIn[21];
	int bHit = FALSE;
	int isResultRow;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getDelReportCGI();

	showHeader(_("Deletion Policy for Binary Data"), _("Set the time at which Binary data is deleted."));

	selectGroup("delete_policy_bin", FALSE);

	if (user.sGroupName[0] == 0) {
		printf("  </table>\n");
		printf("</td></tr></table></p>\n");
		return;
	}

	/* select a host */
	printf("<form method=get>\n");
	printf("<input type=hidden name=\"delete_policy_bin\" value=\"1\">\n");
	
	printf("  <tr>\n");
	printf("    <td align=right width=\"33%%\">%s\n", FONT);
	printf("      %s:&nbsp;&nbsp;\n",_("Select Host"));
	printf("    </font></td>\n");
	printf("    <td>\n");
	printf("    <select name=\"host\">\n");

	g_string_printf(s_SQL, "SELECT perfdata_host.host_name, count(metric)");
	g_string_append_printf(s_SQL, " FROM perfdata_service_metric JOIN perfdata_host ON perfdata_service_metric.host_name = perfdata_host.host_name");
	if (strcmp(user.sGroupName, "**ALL**"))
		g_string_append_printf(s_SQL, " WHERE group_name = '%s'", sql_escape(user.sGroupName,PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, " GROUP BY perfdata_host.host_name");

	query(s_SQL->str);

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif
		printf("    <option value=\"%s\"%s>%s&nbsp;&nbsp;&nbsp;", sData(0), (!strcmp(sHost, sData(0))) ? " selected" : "", sData(0));
		printf(_("(%d Metric%s)\n"), iData(1), (iData(1) == 1) ? "" : "s"); /*FIXME: improve i18n plural here */
	}
	printf("    </select>\n");
	printf("     </td>\n");
	printf("     <td>\n");
	printf("    <input type=submit value=\"%s\">\n",_("Select Host"));
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("</table>\n");

	if (!sHost[0]) {
		printf("</td></form></tr></table></p>\n");
		return;
	} 


	/* Show default host policy */

	iDefaultHostPolicy = getBinHostPolicy(sHost);
	printf("<tr><td align=center>%s%s: %s</font></td></tr>\n",
		FONT, _("Default policy for this host"), getPolicyDesc(iDefaultHostPolicy));
	printf("</td></form></tr></table></p>\n");
			

	/* Some defaults */
	iDefaultPolicy = getDefaultBinPolicy();
	first = getPolicyList();

	/* Adjust policy */
	printf("<form method=get>\n");
	printf("<input type=hidden name=\"delete_policy_bin\" value=\"1\">\n");
	printf("<input type=hidden name=\"host\" value=\"%s\">\n", sHost);
	
	/* main table */
	printf("<p align=center><table width=\"600\" border=1 cellspacing=0 cellpadding=2>\n");
	fflush(stdout);

	printf("<tr bgcolor=\"#FFFFCC\">\n");
	printf("  <td align=center>%s<b>%s</b></font></td>\n", FONT,_("Service"));
	printf("  <td align=center>%s<b>%s</b></font></td>\n", FONT,_("Metric"));
	printf("  <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT,_("Policy"));
	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("  <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT,_("User&nbsp;Defined&nbsp;Policy"));
	}
	printf("</tr>\n");

	g_string_printf(s_SQL, "SELECT service_description, bin_delete_policy, bin_delete_policy_name, bin_delete_policy_type, metric FROM perfdata_service_metric WHERE host_name = '%s'",
		sql_escape(sHost,PERCENT_ESCAPE_CHAR));
	query(s_SQL->str);

	sService[0] = 0;
	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow=0;currentRow<numberOfRows;currentRow++){
	#endif
		sprintf(sTmp, "%s:%s", sData(0), sData(4));
		sHash = s_hash(sTmp);
		sprintf(sDaysOut, "d%sd", sHash);
	
		iPolicyType = sql2ptype(sData(3));
		strcpy(sPolicyName, sData(2));

		/* New values from CGI */
		iPolicyIn = icgi(sHash, -1);
		iDaysIn = icgi(sDaysOut, 0);

		sprintf(sTmp, "pn%s", sHash);
		strcpy(sPolicyNameIn, scgi(sTmp));
		if (sPolicyNameIn[0]) {
			if (!strcmp(sPolicyNameIn, "*USER*")) iPolicyTypeIn = DP_USER;
			else if (!strcmp(sPolicyNameIn, "*HOST*")) iPolicyTypeIn = DP_HOST;
			else iPolicyTypeIn = DP_TEMPLATE;
		} else iPolicyTypeIn = DP_UNSET;

		/* Set policy if changed */
		switch (iPolicyTypeIn) {
		case DP_TEMPLATE:
			iPolicy = getPolicy(sPolicyNameIn);
			if (iPolicyType != DP_TEMPLATE || strcmp(sPolicyName, sPolicyNameIn)) {
				setBinPolicy(sHost, sData(0), sData(4), iPolicy, DP_TEMPLATE, sPolicyNameIn);
				iPolicyType = iPolicyTypeIn;
				strcpy(sPolicyName, sPolicyNameIn);
			}
			break;
		case DP_HOST:
			iPolicy = iDefaultHostPolicy;
			if (iPolicyType != DP_HOST) {
				setBinPolicy(sHost, sData(0), sData(4), iPolicy, DP_HOST, "");
				iPolicyType = iPolicyTypeIn;
			}
			break;
		case DP_USER:
			// What is policy?
			// 1. From CGI.
			// 2. From SQL.
			#ifdef USE_DB_MYSQL
			isResultRow = result_row[1] ? TRUE : FALSE;
			#elif defined USE_DB_POSTGRESQL
			isResultRow = PQgetvalue(query_result,currentRow,1) ? TRUE : FALSE;
			#endif
			switch (iPolicyIn) {
			case 0:
				// Never.  delete_policy = NULL.
				iPolicy = -1;
				if (isResultRow || iPolicyType != DP_USER) {
					setBinPolicy(sHost, sData(0), sData(4), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			case 1:
				// Always.  delete_policy = 0.
				iPolicy = 0;
				if (!isResultRow || iData(1) != 0 || iPolicyType != DP_USER) {
					setBinPolicy(sHost, sData(0), sData(4), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			case 2:
				// Specific days.  delete_policy = iDaysIn
				iPolicy = iDaysIn;
				if (!isResultRow || iData(1) == 0 || iDaysIn != iData(1) || iPolicyType != DP_USER) {
					setBinPolicy(sHost, sData(0), sData(4), iPolicy, DP_USER, "");
					iPolicyType = iPolicyTypeIn;
				}
				break;
			default:
				// No data. Leave as default.
				iPolicy = iDefaultPolicy;
				break;
			}
			break;
		} // END case (policy type)


		printf("<tr>\n");

		/* Service */
		if (!strcmp(sData(0), sService)) {
			printf("  <td bgcolor=\"#%s\"><font size=2>&nbsp;</font></td>\n", sColourHead);
		} else {
			strcpy(sService, sData(0));
			printf("  <td bgcolor=\"#%s\">%s&nbsp;%s&nbsp;</font></td>\n", sColourHead, FONT, sService);
		}
	
		/* Metric */
		printf("  <td bgcolor=\"#%s\">%s&nbsp;%s&nbsp;</font></td>\n", sColourHead, FONT, sData(4));


		// User Policy Value
		printf("<td bgcolor=\"#%s\" align=center>%s", sColourHead, FONT);
		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {

			printf("<select name=\"pn%s\">\n", sHash);
			printf("<option value=\"*USER*\"%s>&lt;%s&gt;\n", 
				(iPolicyType == DP_USER) ? " selected" : "",gettext(STRING_DELETE_POLICY_USER_DEFINED));
			printf("<option value=\"*HOST*\"%s>&lt;%s&gt;\n", 
				(iPolicyType == DP_HOST) ? " selected" : "" ,gettext(STRING_DELETE_POLICY_HOST_DEFAULT));
			for (p = first; p != NULL; p = p->next) {
				printf("<option value=\"%s\"%s>%s\n",
					p->sName,
					(!strcmp(p->sName, sPolicyName) && iPolicyType == DP_TEMPLATE) ? " selected" : "",
					p->sName);
			}
			printf("</select></font></td>\n");

		} else {

			printf("<nobr>");
			if (iPolicyType == DP_USER) {
				printf(gettext(STRING_DELETE_POLICY_USER_DEFINED));
				switch (iPolicy) {
					case -1:
						printf(_(" - Never"));
						break;
					case 0:
						printf(_(" - Always"));
						break;
					default:
						printf(_(" - After %d Days"), iPolicy);
						break;
				}
			}
			if (iPolicyType == DP_HOST) {
				printf(gettext(STRING_DELETE_POLICY_HOST_DEFAULT));
				switch (iPolicy) {
					case -1:
						printf(_(" - Never"));
						break;
					case 0:
						printf(_(" - Always"));
						break;
					default:
						printf(_(" - After %d Days"), iPolicy);
						break;
				}
			}
			else {
				for (p = first; p != NULL; p = p->next) {
					if (!strcmp(p->sName, sPolicyName) && iPolicyType == DP_TEMPLATE) {
						printf("%s\n", p->sName);
						bHit = TRUE;
						break;
					}
				}
				if (!bHit) printf(_("Unknown\n"));
			}

		}
	

		/* Policy */
		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
			printf("  <td bgcolor=\"#%s\">%s<nobr>", sColour, FONT);
			printf("<input type=radio name=\"%s\" value=\"0\"%s>%s&nbsp;&nbsp;", 
				sHash, (iPolicy == -1) ? " checked" : "",_("Never"));
			printf("<input type=radio name=\"%s\" value=\"1\"%s>%s&nbsp;&nbsp;", 
				sHash, (iPolicy == 0) ? " checked" : "",_("Always"));
			printf("<input type=radio name=\"%s\" value=\"2\"%s>%s:", 
				sHash, (iPolicy > 0) ? " checked" : "",_("After&nbsp;Days"));
			printf("<input type=text name=\"%s\" value=\"%d\" size=4 maxlength=6>\n", 
				sDaysOut, (iPolicy > 0) ? iPolicy : 
				(iDefaultPolicy > 0) ? iDefaultPolicy : 0);
			printf("  </font></td>\n");
		}

		printf("</tr>\n");

	}

	printf("</table></p>\n");

	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<p align=center>\n");
		printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\">\n");
		printf("<tr>\n");
		printf("  <td align=center><input type=submit value=\"%s\"></td>\n",_("Update Policy"));
		printf("</tr>\n");
		printf("</table></p>\n");
	}

	printf("</form>\n");

}



void getDelReportCGI()
{

	sHost = strdup(scgi("host"));
	sService = strdup(scgi("service"));
	sMetric = strdup(scgi("metric"));

}




/* Mark hosts for deletion at later time */
void markForDeletion()
{
	int		bHeader = FALSE;
	char	sHash[12];
	int		iSet, iChanges = 0;
	int		bSubmit;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	getDelReportCGI();

	showHeader(_("Mark Host for complete deletion."), "");

	selectGroup("mark_for_deletion", TRUE);

	if (!user.sGroupName[0]) return;

	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<p align=center>\n");
		printf("  <table width=\"600\" border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
		printf("    %s%s", FONT,_("<b>Note:</b> Host and Host Data will be deleted when\n"
		"    <font fact=\"Courier\">perfparse-db-purge</font> is next run.\n"
		"    Please dissable performance data in Nagios for any hosts you wish to delete.\n"
		"    Otherwise hosts will be regenerated on next import of data from that host."));
		printf("    </font></p>\n");
		printf("  </table>\n");
		printf("</p>\n");
	}


	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<form method=get>\n");
		printf("<input type=hidden name=\"mark_for_deletion\" value=\"1\">\n");
		printf("<input type=hidden name=\"submit\" value=\"1\">\n");
	}

	bSubmit = icgi("submit", FALSE);


	g_string_printf(s_SQL, "SELECT host_name, group_name, is_deleted");
	g_string_append_printf(s_SQL, " FROM perfdata_host");
	if (strcmp(user.sGroupName, "**ALL**"))
		g_string_append_printf(s_SQL, " WHERE group_name = '%s'", sql_escape(user.sGroupName,PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, " ORDER BY host_name");
	query(s_SQL->str);

	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
		strcpy(sHash, s_hash(sData(0)));

		if (bSubmit) {
			iSet = icgi(sHash, 0);
			if (iSet != iData(2)) {
			/* Need to toggle the setting */
				g_string_printf(s_SQL, "UPDATE perfdata_host SET is_deleted = %d WHERE host_name = '%s'",
					iSet, sql_escape(sData(0), PERCENT_ESCAPE_CHAR));
				query_no_return(s_SQL->str);
				iChanges++;
			}
		} else {
			iSet = iData(2);
		}
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
		strcpy(sHash, s_hash(sData(0)));

		if (bSubmit) {
			iSet = icgi(sHash, 0);
			if (iSet != bData(2)) {
			/* Need to toggle the setting */
				g_string_printf(s_SQL, "UPDATE perfdata_host SET is_deleted = %s WHERE host_name = '%s'",
					iSet ? "true" : "false", sql_escape(sData(0), PERCENT_ESCAPE_CHAR));
				query_no_return(s_SQL->str);
				iChanges++;
			}
		} else {
			iSet = bData(2);
		}
	#endif		
	
		if (!bHeader) {
			bHeader = TRUE;
			printf("<p align=center>\n");
			printf("  <table width=\"600\" border=1 cellpadding=2 cellspacing=0>\n");
			printf("    <tr bgcolor=\"#FFFFCC\">\n");
			printf("      <td align=center>%s<b>%s</b></font></td>\n", FONT,_("Host"));
			printf("      <td align=center>%s<b>%s</b></font></td>\n", FONT,_("Group"));
			printf("      <td align=center width=\"1%%\">%s<b>%s</b></font></td>\n", FONT, _("Delete"));
			printf("    </tr>\n");
		}
	
		printf("    <tr bgcolor=\"#FFFFFF\">\n");

		/* Host */
		printf("      <td>%s&nbsp;%s&nbsp;</font></td>\n", FONT, sData(0));

		/* Group */
		printf("      <td>%s&nbsp;%s&nbsp;</font></td>\n", FONT, sData(1));

		/* Is Deleted */
		printf("      <td align=center>\n");
		if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
			printf("        <input type=checkbox name=\"%s\" value=\"1\"%s>\n",
				sHash, (iSet) ? " checked" : "");
		} else {
			printf("        %s%s</font>\n", FONT, sData(2));
		}
		printf("      </td>\n");

		printf("    </tr>\n");


	}

	if (bHeader) {
		printf("  </table>\n");
		printf("</p>\n");
	}

	if (!strcmp(config_get_value_as_string(CONFIG_ITEM_ID_DEFAULT_USER_PERMISSIONS_POLICY), USER_PERMISSIONS_RW)) {
		printf("<p align=\"center\"><input type=\"submit\" value=\"Set\"></p>\n");
		printf("</form>\n");
	}

	if (iChanges) {
		printf("<p align=\"center\">%s%d %s%s %s.</font></p>\n", FONT, iChanges,
			_("change"), (iChanges == 1) ? "" : "s",_("saved"));
	}

}

