/*****************************************************************************
 *
 * cgi_select_object - CGI to select an object.
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <config.h>
#include <gettext.h>
#include "libpp_common.h"
#include "cgi_select_object.h"

void displaySelectHost()
{
	char sGroup[76] = "";
	char sCurrentGroup[76] = "";
	int  bHit = FALSE;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td width=60><img src=\"%s%s/perfparse-logo-sm.png\" border=0></td>\n", 
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      <b>%s</b><br>\n",_("Select Host to Graph"));
	printf("      <a href=\"%s\">%s</a>\n", sProgName,_("Return to main menu"));
	printf("    </td>\n");
	printf("    <td width=60 align=right><font face=\"Arial, Helvetica\" size=1>v%s</td>\n", VERSION);
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

	// Select host:

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td align=center>\n");
	
	query("SELECT host_name, group_name FROM perfdata_host ORDER BY group_name, host_name");
	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif
		strcpy(sCurrentGroup, sData(1));
		if (!sCurrentGroup[0]) strcpy(sCurrentGroup, "Unassigned");
		if (strcmp(sCurrentGroup, sGroup)) {
			if (bHit) {
				printf("</td></tr></table>\n");
			}
			bHit = TRUE;
			printf("<font face=\"Arial, Helvetica\" size=2><b>%s</b>&nbsp;%s\n", _("Group:"), sCurrentGroup);
			printf("<table width=\"100%%\" border=1 cellpadding=5 cellspacing=0 bgcolor=\"#FFFFFF\"><td><font face=\"Arial, Helvetica\" size=2>\n");
		}
		printf("<nobr><a href=\"%s?select_metric=1&host_name=%s\">%s</a></nobr>&nbsp;&nbsp;", sProgName,
			url_encode(sData(0)), sData(0));
		strcpy(sGroup, sCurrentGroup);
	}
	printf("</td></tr></table>\n");
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

}

void displaySelectMetric()
{
	char sHostName[76];
	char sService[76] = "";
	int  bHit = FALSE;

	#ifdef USE_DB_POSTGRESQL
	int numberOfRows;
	#endif

	strcpy(sHostName, scgi("host_name"));

	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td width=60><img src=\"%s%s/perfparse-logo-sm.png\" border=0></td>\n", 
		(HTTP_IMAGE_PATH[0] == '/') ? "" : "/", HTTP_IMAGE_PATH);
	printf("    <td align=center><font face=\"Arial, Helvetica\" size=2>\n");
	printf("      <b>%s<br>'%s'</b><br><br>\n", _("Select Metric to Graph for host:"), sHostName);
	printf("      <a href=\"%s\">%s</a>\n", sProgName,_("Return to main menu"));
	printf("      <a href=\"%s?select_host=1\">%s</a>\n", sProgName,_("Select new host"));
	printf("    </td>\n");
	printf("    <td width=60 align=right><font face=\"Arial, Helvetica\" size=1>v%s</td>\n", VERSION);
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

	// Select Metric:


	printf("<p align=center>\n");
	printf("<table width=600 border=1 cellpadding=5 cellspacing=0 bgcolor=\"#CCCCCC\"><tr><td>\n");
	printf("  <table width=\"100%%\" border=0 cellpadding=0 cellspacing=0>\n");

	printf("  <tr>\n");
	printf("    <td align=center>\n");

	g_string_printf(s_SQL, "SELECT service_description, metric FROM perfdata_service_metric");
	g_string_append_printf(s_SQL, " WHERE host_name = '%s' ORDER BY service_description, metric", sql_escape(sHostName,PERCENT_ESCAPE_CHAR));
	query(s_SQL->str);
	#ifdef USE_DB_MYSQL
	while ((result_row = mysql_fetch_row(query_result))) {
	#elif defined USE_DB_POSTGRESQL
	numberOfRows = rows();
	for (currentRow = 0; currentRow<numberOfRows; currentRow++){
	#endif
		if (strcmp(sData(0), sService)) {
			if (bHit) {
				printf("</td></tr></table>\n");
			}
			bHit = TRUE;
			printf("<font face=\"Arial, Helvetica\" size=2><b>%s</b>&nbsp;%s</font>\n", _("Service:"), sData(0));
			printf("<table width=\"100%%\" border=1 cellpadding=5 cellspacing=0 bgcolor=\"#FFFFFF\"><td><font face=\"Arial, Helvetica\" size=2>\n");
		}
		printf("<a href=\"%s?graph=1&host=%s", sProgName, url_encode(sHostName));
		printf("&service=%s", url_encode(sData(0)));
		printf("&metric=%s", url_encode(sData(1)));
		printf("\">%s</a>\n", sData(1));
		strcpy(sService, sData(0));
	}
	if (bHit) {
		printf("</td></tr></table>\n");
	}
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("  </table>\n");

	printf("</td></tr></table></p>\n");

}



