#! /bin/sh

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin

PROGNAME=`basename $0`
PROGPATH=`echo $0 | sed -e 's,[\\/][^\\/][^\\/]*$,,'`
REVISION=1.1

STATE_OK=0
STATE_WARNING=1
STATE_CRITICAL=2
STATE_UNKNOWN=3
STATE_DEPENDENT=4

print_version () {
		echo $PROGNAME $REVISION
}

print_usage() {
        echo "Usage: $PROGNAME <perfparse drop file path>"
}

print_help() {
        print_version
        echo ""
        print_usage
        echo ""
        echo "This plugin tests the presence of the Perfparse Drop File"
        echo ""
        exit 0
}

if [ $# -ne 1 ]; then
        print_usage
        exit 0
fi

DROPFILE=$1

case "$1" in
        --help)
                print_help
                exit 0
                ;;
        -h)
                print_help
                exit 0
                ;;
        --version)
				print_version
                exit 0
                ;;
        -V)
                print_version
                exit 0
                ;;
        *)
				if [ -f ${DROPFILE} ]; then
					NB_LINES=`cat ${DROPFILE} | wc -l`
					NB_LINES=`expr ${NB_LINES}`
					ZERO=0
					if [ ${NB_LINES} -eq ${ZERO} ]; then
                        echo "OK - ${DROPFILE} exists but is empty"
                        exit ${STATE_OK}
					else
						echo "CRITICAL - ${DROPFILE} exists and contains ${NB_LINES} lines"
						exit ${STATE_CRITICAL}
					fi
                else
                        echo "OK - ${DROPFILE} does not exist"
                        exit ${STATE_OK}
                fi
                ;;
esac
