#ifndef PP_DEL_POLICY_H
#define PP_DEL_POLICY_H

#define DP_UNSET		0
#define DP_USER			1
#define DP_TEMPLATE		2
#define DP_HOST			3

#define DEFAULT_DELETE_POLICY_DAYS 30

typedef struct {
	char *sName;
	int iPolicy;
	void *next;
} TPolicyList;


/* Working with perfdata_delete_policy records */
void editPolicy(char *sPolicyName, int iPolicy);
void deletePolicyName(char *sPolicy);
int isPolicyDefined(char *sPolicyName);
int getPolicy(char *sPolicyName);

/* Definition of policies against other tables. */
void setBinPolicy(char *sHostIn, char *sServiceIn, char *sMetricIn,  int iPolicy, int iPolicyType, char *sTemplate);
void setRawPolicy(char *sHostIn, char *sServiceIn, int iPolicy, int iPolicyType, char *sTemplate);
void setBinHostPolicyUser(char *sHostIn, int iPolicy);
void setBinHostPolicyTemplate(char *sHostIn, char *sTemplate);
void setRawHostPolicyUser(char *sHostIn, int iPolicy);
void setRawHostPolicyTemplate(char *sHostIn, char *sTemplate);

/* general helpers */
char *pval2sql(int iPolicy);
int sql2pval(const char *sPolicy);
char *ptype2sql(int iType);
int sql2ptype(const char *sType);

char *getPolicyDesc(int iPolicy);
int  getRawHostPolicy(char *sHost);
int  getBinHostPolicy(char *sHost);

void validateDefaultDP();
int  isDefaultDP(char *sPolicy);

int getDefaultBinPolicy();
int getDefaultRawPolicy();

/* Policy List */
TPolicyList *getPolicyList();
void destroyPolicyList(TPolicyList *first);










#endif

