/*****************************************************************************
 *
 * storage_stdout.c - Parse Nagios data and store in relational database.
 *
 * Copyright (c) 2004 Yves Mettier (ymettier@libertysurf.fr)
 * Last Modified:   2004-09-01
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#define STORAGE_STDOUT_VERSION "0.0.1"


#include <stdio.h>
#include <stdlib.h>
#include <libnagios_perfdata_parser.h>
#include "libpp_storage.h"

#include <config.h>
#include <gettext.h>

int storage_stdout_store_line(storage_module_t *this, const log_line_t *log_data) {
	printf("%s\t%s\t%s\t%s\t%s\t%s\n", 
			log_data->macro[LOG_LINE_TIMET],
			log_data->macro[LOG_LINE_HOSTNAME],
			log_data->macro[LOG_LINE_SERVICEDESC],
			log_data->macro[LOG_LINE_OUTPUT],
			log_data->macro[LOG_LINE_SERVICESTATE],
			log_data->macro[LOG_LINE_PERFDATA]);
	return(0);
}

storage_module_t* storage_module_init(void) {
	storage_module_t *sm;
	sm = storage_new("Stdout", STORAGE_STDOUT_VERSION);
	if(NULL == sm) return(NULL);
	sm->store_line = storage_stdout_store_line;
	sm->enabled = 1;
	return(sm);
}

